program Melodie;
uses dos,crt;
Type melodientyp = string[255];
const melodienzahl :byte = 7;
      fanfare : melodientyp = (CHR(0)+CHR(20)+'AHHHAHHHcHGHcHeH');
      oliver_maass : melodientyp = (chr(0)+chr(20)+
'AH*sGaGs*sGsAaAs*sHaHs*sAaAs*sAsGaGs*sAh*aEa*aGaGs*sAaAs*sAsHa*aAa*aGa*aAa*aGa*aAH*sGAGV*zEAEV*ZDADV*ZHg');
      chromatische_tonleiter : melodientyp = (chr(1)+chr(0)+
      'CVIVDVSVEVFVQVGVTVAVBVcViVdVsVeVfVqVgVtVaVbV1V2V3V4V5V6V7V8V9V0V#H');
      bruder_jakob : melodientyp = (chr(0)+chr(30)+
'FV*ZGV*ZAV*ZFV*ZFV*ZGV*ZAV*ZFV*ZAV*ZBV*ZcH*ZAV*ZBV*ZcH*ZcA*ZdA*ZcA*ZBA*ZAV*ZFV*ZcA*ZdA*ZcA*ZBA'+
'*ZAV*ZFV*ZGV*ZCV*ZFH*ZGV*ZCV*ZFH');
      abendlied : melodientyp = ( chr(0)+chr(35)+
'cV*ZBV*ZAV*ZcV*ZBV*ZAV*ZdV*ZcV*ZBV*ZAV*ZGH*ZAV*ZBV*ZcV*ZBV*ZAV*ZAV*ZGV*ZFGFV');
      Der_edle_sheriff : melodientyp = (chr(0)+chr(45)+
'HScS*ZdV*ZeA*ZdV*ZdA*ZcVcA*ZHVHA*ZAVHA*ZGV*ZHA*ZAVHA*ZGV*SHScS*ZdV*ZeA*ZdV*ZdA*ZcVcA*ZHVHA*ZAVHA*ZAVGA*ZGHGA');
      dER_EDLE_Sheriff_Fortsetzung : melodientyp = (chr(0)+chr(45)+
'*SASHS*ZcV*ZdA*ZcV*ZGA*ZcV*ZdA*ZcV*ZGA*ZcV*ZeA*ZdV*ZcA*ZdVdA*ZHVHA*ScVcA*ZEV*ZFA*ZGV*ZAA*ZHV*ZcA*ZdVHA*ZdVHA*ZAVAA*ZGV');
      Bourree : melodientyp = (chr(0)+chr(30)+
'ca*zda*zcv*zGv*zcv*zdv*zea*zda*zea*zfa*zev*zgv*zdv*zev*zfv*zea*zfa*zda*zca*zda*zea*zdv*sca*zda*zcv*zGv*zcv*zdv*zea*zda*z'+
'ea*zfa*zev*zgv*zdv*zev*zfv*zea*zfa*zdhdv');
      Bourree_fortsetzung : melodientyp = (chr(0)+chr(30)+
'*sda*zea*zdv*zHv*zcv*zdv*zGa*zFa*zGa*zAa*zGv*zAa*zHa*zcv*zHa*zca*zdv*zca*zda*zea*zda*zea*zfa*zev*sda*zea*zdv*zHv*zcv*zdv*z'+
'GA*ZFA*ZGA*ZAA*ZGv*ZAa*ZHA*ZcA*ZHA*ZcA*ZdA*Zdvdaca*zchcv');
      Vogelfanger : melodientyp = (chr(0)+chr(77)+
'hsas*zgs*sgs*sasgsqsgs*zas*shs*sas*sasqs*zdads*zds*z3a*s3s*zhs*sas*sgs*sgshs*zasgsqsgs*zasgsqsgs*zas*shs*sas*sas*s3a*s3s*z'+
'aa*sas*zqs*ses*sds*sdsqs*zas*sas*shsasgsas*zhs*sas*sgs*s3a*z3sqa*zqs*zasgsqsgs*zas*shs*sas*sqaga*zgzazhz1z*z3s*zqaga*zgzaz');
      Vogelfanger_fortsetzung : melodientyp = (chr(0)+chr(77)+'hz1z*z3a*zgsas*zhahs*zhs*z1shsashs*z1s*s3s*s5a1sas*zqaqs*zqs'+
'*zgsqsesfs*zgshsasqs*zga*zgzazhz1z*z3a*zqaga*zgzazhzcz*z3a*zqaga*zgsds*zHaHs*zds*zdsCSHSAS*zGa*zhs*sgs*s');
      katharina : melodientyp = (chr(0)+chr(30)+
'cvevgvev1vhvavgvev1vhvavgvevfvdvgvevfvdvgvevcvevgvev1vhvavgvev1vhvavgvevevcvfvdvevevdvch');

var pausenzahl : word;
    aktmelodie : ^melodientyp;
    tonzahler : byte;
    welchemelodie : byte;
    code : integer;

procedure Pause(Pausenlange:word);
var zahler : word;
begin
  for zahler:=1 to pausenlange do begin
    delay(1);
    if keypressed then begin
      nosound;
      halt(1);
    end;
  end;
end;

procedure spiele(ton,pausen:char);
begin
  case ton of
    'C' : sound(262);
    'I' : sound(277);
    'D' : sound(294);
    'S' : sound(311);
    'E' : sound(330);
    'F' : sound(349);
    'Q' : sound(370);
    'G' : sound(392);
    'T' : sound(415);
    'A' : sound(440);
    'B' : sound(466);
    'H' : sound(494);
    'c' : sound(523);
    'i' : sound(554);
    'd' : sound(587);
    's' : sound(622);
    'e' : sound(659);
    'f' : sound(698);
    'q' : sound(740);
    'g' : sound(784);
    't' : sound(831);
    'a' : sound(880);
    'b' : sound(932);
    'h' : sound(988);
    '1' : sound(1047);
    '2' : sound(1109);
    '3' : sound(1175);
    '4' : sound(1245);
    '5' : sound(1319);
    '6' : sound(1397);
    '7' : sound(1480);
    '8' : sound(1568);
    '9' : sound(1661);
    '0' : sound(1760);
    '#' : sound(1864);
    '*' : nosound;
  end;
  case upcase(pausen) of
    'G' : pause(32*pausenzahl);
    'H' : pause(16*pausenzahl);
    'T' : pause((16*pausenzahl) div 3);
    'V' : pause(8*pausenzahl);
    'A' : pause(4*pausenzahl);
    'S' : pause(2*pausenzahl);
    'Z' : pause(pausenzahl);
  end;
end;

procedure abspielen;
begin
  pausenzahl:=(ord(aktmelodie^[1])*255+ord(aktmelodie^[2]));
  tonzahler:=3;
  repeat
    spiele(aktmelodie^[tonzahler],aktmelodie^[succ(tonzahler)]);
    inc(tonzahler,2);
  until (length(aktmelodie^)<=tonzahler);
  nosound;
end;

begin
  if keypressed then halt(1);
  randomize;
  nosound;
  if (paramcount=0) then welchemelodie:=random(melodienzahl)
  else begin
    val(paramstr(1),welchemelodie,code);
    if ((code<>0) or (welchemelodie>melodienzahl)) then welchemelodie:=random(melodienzahl);
  end;
  case welchemelodie of
    0 : begin
          aktmelodie:=@bruder_jakob;
          abspielen;
        end;
    1 : begin
          aktmelodie:=@abendlied;
          abspielen;
        end;
    2 : begin
          aktmelodie:=@Der_edle_sheriff;
          abspielen;
          aktmelodie:=@Der_edle_sheriff_fortsetzung;
          abspielen;
          abspielen;
        end;
    3 : begin
          aktmelodie:=@bourree;
          abspielen;
          abspielen;
          aktmelodie:=@bourree_fortsetzung;
          abspielen;
          abspielen;
        end;
    4 : begin
          aktmelodie:=@oliver_maass;
          abspielen;
        end;
    5 : begin
          aktmelodie:=@vogelfanger;
          abspielen;
          aktmelodie:=@vogelfanger_fortsetzung;
          abspielen;
        end;
    6 : begin
          aktmelodie:=@katharina;
          abspielen;
        end;
  end;
end.