program nutzung;
{$M 16384,0,327680}
uses vga,graph,dos,crt,maus;
const maxuse=8;
      mlange:array[1..12] of byte=(31,28,31,30,31,30,31,31,30,31,30,31);
      days : array [0..6] of String[11] =
       ('Sonntag','Montag','Dienstag',
        'Mittwoch','Donnerstag','Freitag',
        'Samstag');
      auWrite=1;
      auKopf=2;
      auSchluss=4;
      auZeit=8;
      auPark=16;
      auWarn=32;
      soIntern=0;
      soNone=1;
      soExtern=2;
type nutzstr=string[15];
     nutzertyp=record
        kennung:string[11];
        n:array[0..maxuse] of record
          name:nutzstr;
          zeichen:char;
          farbe:byte;
        end;
        path:pathstr;
        auto,sound:word;
        command:string;
        params:string;
      end;
      Tmultiuser=string[maxuse+2];
      Tmultiuserfarbe=record
                   anz:byte;
                   farbe:array[0..maxuse] of byte;
                 end;

{Ab hier }
const nutzer:nutzertyp={(kennung:'NUTZUNG 1.3';
                     n:((name:'';zeichen:' ';farbe:green),
                        (name:'';zeichen:' ';farbe:blue),
                        (name:'';zeichen:' ';farbe:yellow),
                        (name:'';zeichen:' ';farbe:lightred),
                        (name:'';zeichen:' ';farbe:brown),
                        (name:'';zeichen:' ';farbe:cyan),
                        (name:'';zeichen:' ';farbe:white),
                        (name:'';zeichen:' ';farbe:magenta),
                        (name:'';zeichen:' ';farbe:lightgray));
                        path:'';
                        auto:auZeit+auWrite+auSchluss+auPark;
                        sound:soNone;
                        command:'';
                        params:''
                        );}
                       (kennung:'NUTZUNG 1.3';
                     n:((name:'Florian';zeichen:'F';farbe:green),
                        (name:'Mathias';zeichen:'M';farbe:blue),
                        (name:'Katharina';zeichen:'K';farbe:yellow),
                        (name:'Hans';zeichen:'H';farbe:lightred),
                        (name:'Gast';zeichen:'G';farbe:brown),
                        (name:'';zeichen:' ';farbe:cyan),
                        (name:'';zeichen:' ';farbe:white),
                        (name:'';zeichen:' ';farbe:magenta),
                        (name:'';zeichen:' ';farbe:lightgray));
                        path:'c:\dienst\';
                        auto:auZeit+auWrite+auKopf+auSchluss+auPark+auWarn;
                        sound:soExtern;
                        command:'d:\dienst\mp.com';
                        params:'-q -s *.mod'
                        );

{Bis hier wird beschrieben}
const loginexists:boolean=false;
      dow:word=1;
      dt:datetime=(year:1992;month:4;day:11;hour:12;min:00;sec:00);
      logindt:datetime=(year:1992;month:4;day:11;hour:12;min:00;sec:00);
      zeitdt:datetime=(year:1992;month:4;day:11;hour:12;min:00;sec:00);
      loginuser:Tmultiuser='';
      param:string=' ';

  {$L EGAVGA}
  procedure EGAVGAdriver;external;
  {$L GOTH}
  procedure GOTHICOBJ;external;

  function fileexist(name:string):boolean;
  var search:searchrec;
  begin
    search.name:=name;
    findfirst(name,anyfile,search);
    fileexist:=doserror=0;
  end;


  function LeadingZero(w : Word) : String;
  var
    s : String;
  begin
    Str(w:0,s);
    if Length(s) = 1 then
      s := '0' + s;
    LeadingZero := s;
  end;

  function tagabstand(d,m,y,vd,vm,vy:integer):integer;
  var h:integer;
  begin
    h:=0;
    while y<vy do begin
      if ((y div 4)=0) and ((y div 200)<>0) then inc(h);
      inc(y);
      inc(h,365);
    end;
    if m<vm then begin
      while m<vm do begin
        inc(h,mlange[m]);
        inc(m);
      end;
    end else begin
      while m>vm do begin
        dec(h,mlange[m]);
        dec(m);
      end;
    end;
    tagabstand:=h+(vd-d);
  end;

  function usernr(user:char):byte;
  var n:byte;
  begin
    n:=0;
    while (n<maxuse) and (nutzer.n[n].zeichen<>user) do inc(n);
    usernr:=n;
  end;

  procedure ausnutzung(logname:pathstr);
  type Tnutzstat=array[0..maxuse] of record
                   anzahl,minuten:longint;
                 end;
  type richtungstyp=(vor,vornichts,zurucknichts,zuruck);
  const maxeintrag=2500;
        monatanders:boolean=true;
        grafikan:boolean=false;
        zeitsumgezeigt:boolean=false;
        fensterstarttag:word=0;
        aktminnutz:word=0;
        aktmaxnutz:word=0;
        Zeitsum:longint=0;
        maxtaganzeigen:byte=62;
        nutzstatmaxanz:longint=0;
        nutzstatmaxmin:longint=0;
        nutzstatgesanz:longint=0;
        nutzstatgesmin:longint=0;
        maxtagabstand:longint=0;
        nutzstat:Tnutzstat=((anzahl:0;minuten:0),
                            (anzahl:0;minuten:0),
                            (anzahl:0;minuten:0),
                            (anzahl:0;minuten:0),
                            (anzahl:0;minuten:0),
                            (anzahl:0;minuten:0),
                            (anzahl:0;minuten:0),
                            (anzahl:0;minuten:0),
                            (anzahl:0;minuten:0));
  type eintrstr=string[69];
       TEintrag=record
                  userfarbe:Tmultiuserfarbe;
                  tag,beg,ende:integer;
                  text:pointer;
                end;
       TEintrage=array[0..maxeintrag] of Teintrag;
       Peintrage=^Teintrage;
  var nutz:Peintrage;
      maxx,maxy,maxnutz,h,y,m,d:word;
      ein:char;
      graphdriver:integer;

    procedure grafikein;
    var graphmode,error:integer;
        pfad:string;
    begin
      if (registerbgidriver(@EGAVGAdriver)<0) or
         (registerbgifont(@gothicobj)<0) then begin
         writeln('Fehler beim Anmelden der Grafiktreiber!',^G);
         halt(1);
      end;
      pfad:='';
      repeat
        graphdriver:=detect;
        detectgraph(graphdriver,graphmode);
        if (graphdriver<>ega) and (graphdriver<>graph.vga) then begin
          writeln('Ich gebe Dir einen Tip:');
          writeln('Kauf Dir ''ne VGA Karte !');
          readln;
          halt(1);
        end;
        initgraph(graphdriver,graphmode,pfad);
        error:=graphresult;
        if error<>0 then begin
          writeln(grapherrormsg(error));
          write(^G,'Geben Sie Ihren Grafik Pfad ein : ');
          readln(pfad);
          if pfad='' then halt(1);
        end;
      until error=0;
      grafikan:=true;
      maxx:=getmaxx;
      maxy:=getmaxy;
      setbkcolor(lightgray);
      overscan(lightgray);
      setfillstyle(solidfill,0);
    end;

    procedure grafik;
    var n:integer;
        buf:string[3];
        ende:word;
    begin
      n:=19;
      setcolor(white);
      if graphdriver=graph.vga then ende:=maxy-24 else ende:=maxy-30;
      while n<=maxx do begin
        line(n,15,n,ende);
        inc(n,10);
      end;
      n:=15;
      while n<maxy-15 do begin
        setcolor(white);
        line(19,n,maxx,n);
        setcolor(lightblue);
        if graphdriver=graph.vga then begin
          str((n+5) div 20+2:2,buf);
          inc(n,20);
        end else begin
          str((n+5) div 16+5:2,buf);
          inc(n,16);
        end;
        if n<maxy-30 then outtextxy(0,n-4,buf);
      end;
      maxtaganzeigen:=(maxx-15) div 10;
      setcolor(red);
      outtextxy(maxx-80,0,'Statistik');
      settextstyle(gothicfont,horizdir,1);
      moveto(50,maxy-25);
      for n:=0 to maxuse do begin
        setcolor(nutzer.n[n].farbe);
        outtext(nutzer.n[n].name+' ');
      end;
    end;

    procedure lesenutz;
    var t:text;
        zeile,akt:word;
        suche:searchrec;
        uberschritten:boolean;
        tag,day,month,year,mitternacht,beghour,begmin,endhour,endmin:word;
        n,z:byte;
        text:string;
        gm:integer;
        user:Tmultiuser;
        ein:char;

      procedure eintrag(use:Tmultiuser;ta,beho,bemin,endho,endmin:integer;tex:eintrstr);      var min:integer;
          m:byte;
      begin
        for m:=1 to length(use) do begin
          n:=usernr(use[m]);
          inc(nutzstat[n].anzahl);
          if nutzstat[n].anzahl>nutzstatmaxanz then
             nutzstatmaxanz:=nutzstat[n].anzahl;
          min:=(endho-beho)*60+endmin-bemin;
          inc(nutzstat[n].minuten,min);
          inc(nutzstatgesmin,min);
          if nutzstat[n].minuten>nutzstatmaxmin then
             nutzstatmaxmin:=nutzstat[n].minuten;
          inc(nutzstatgesanz);
          nutz^[akt].userfarbe.farbe[pred(m)]:=nutzer.n[n].farbe;
        end;
        nutz^[akt].userfarbe.anz:=pred(length(use));
        if maxtagabstand<ta then maxtagabstand:=ta;
        with nutz^[akt] do begin
          tag:=ta;
          if graphdriver=graph.vga then begin
            beg:=(beho*60+bemin) div 3-25;
            ende:=(endho*60+endmin) div 3-25;
            if ende>maxy-24 then ende:=456;
            if beg>maxy-24 then beg:=456;
          end else begin
            beg:=(beho*60+bemin)*4 div 15-65;
            ende:=(endho*60+endmin)*4 div 15-65;
            if ende>maxy-30 then ende:=320;
            if beg>maxy-30 then beg:=320;
          end;
          if beg<0 then
          beg:=15;
          if ende<0 then
          ende:=15;
          while pos(' ',tex)=1 do delete(tex,1,1);
          if length(tex)>0 then begin
            getmem(text,succ(length(tex)));
            move(tex[0],text^,succ(length(tex)));
          end else text:=nil;
        end;
        inc(akt);
        if akt>maxeintrag then begin
          akt:=0;
          uberschritten:=true;
        end;
      end;

    begin
      h:=dt.hour;m:=dt.month;y:=dt.year;d:=dt.day;
      graphdriver:=detect;
      detectgraph(graphdriver,gm);
      if fileexist(nutzer.path+logname+'.DAT') then
        assign(t,nutzer.path+logname+'.DAT')
      else if fileexist(logname) then
        assign(t,logname)
      else begin
        writeln(^G,nutzer.path+logname+'.DAT oder ',logname,' nicht gefunden ');
        readln;
        halt(1);
      end;
      reset(t);
      akt:=0;
      uberschritten:=false;
      zeile:=0;
      while not eof(t) do begin
        user:='';
        repeat
          read(t,ein);
          if ein<>' ' then user:=user+ein;
        until ein=' ';
        readln(t,day,month,year,mitternacht,beghour,begmin,endhour,endmin,text);
        inc(zeile);
        if ioresult<>0 then begin
          writeln('Fehler in '+logname+'.DAT in Zeile ',zeile,^G);
          readln;
          halt(1);
        end;
        if year>90 then inc(year,1900) else inc(year,2000);
        tag:=tagabstand(day,month,year,dt.day,dt.month,dt.year);
        if mitternacht>0 then begin
          eintrag(user,tag,beghour,begmin,23,59,text);
          beghour:=0;
          begmin:=1;
          dec(tag);
          dec(nutzstatgesanz);
          for z:=2 to mitternacht do begin
            eintrag(user,tag,0,1,23,59,text);
            dec(tag);
            dec(nutzstatgesanz);
          end;
        end;
        eintrag(user,tag,beghour,begmin,endhour,endmin,text);
      end;
      close(t);
      with nutz^[akt] do begin
        if loginexists then begin
          eintrag(loginuser,tagabstand(logindt.day,logindt.month,logindt.year,dt.day,dt.month,dt.year),
                  logindt.hour,logindt.min,dt.hour,dt.min,'Das bist Du gerade jetzt !');
        end;
        maxnutz:=pred(akt);
      end;
      aktmaxnutz:=succ(maxnutz);
      if uberschritten then maxnutz:=maxeintrag;
    end;

    function tagausgabe(var starteintrag:word;richtung:richtungstyp;fensterstarttag:word):boolean;
    var h:word;

      procedure markiere(var eintrag:word);
      var spalte,n,e:word;
          h,anz:byte;
      begin
        with nutz^[eintrag] do begin
          spalte:=(succ(maxtaganzeigen)-tag+fensterstarttag)*10;
          anz:=succ(userfarbe.anz);
          if anz>1 then begin
            h:=0;
            e:=pred(ende);
            for n:=spalte to spalte+8 do begin
              setcolor(userfarbe.farbe[h div 9]);
              inc(h,anz);
              line(n,beg,n,e);
            end;
          end else begin
            e:=pred(ende);
            setcolor(userfarbe.farbe[0]);
            for n:=spalte to spalte+8 do line(n,beg,n,e);
          end;
        end;
      end;

    begin
      h:=nutz^[starteintrag].tag;
      repeat
        if (richtung=vor) or (richtung=zuruck) then markiere(starteintrag);
        case richtung of
          vor,vornichts:if starteintrag<maxnutz then inc(starteintrag) else begin
                inc(starteintrag);
                tagausgabe:=false;
                exit;
              end;
          zuruck,zurucknichts:if starteintrag>0 then dec(starteintrag) else begin
                tagausgabe:=false;
                exit;
              end;
        end;
      until (nutz^[starteintrag].tag<>h);
      tagausgabe:=true;
    end;

    procedure letzttaganzeige;
    var buf:string[4];
    begin

      {Provisorium}

      bar(508,maxy-20,maxx,maxy);
      setcolor(magenta);
      moveto(508,maxy-25);
      settextstyle(gothicfont,horizdir,1);
      setwritemode(normalput);
      str(d:2,buf);outtext(buf+'.');
      str(m:2,buf);outtext(buf+'.');
      str(y:4,buf);outtext(buf+'');
      setwritemode(xorput);
      settextstyle(defaultfont,horizdir,1);
      setcolor(white);
    end;

    procedure datenausgabe;
    var akt:word;
    begin
      letzttaganzeige;
      setwritemode(xorput);
      akt:=maxnutz;
      {$B+}
      while (nutz^[akt].tag<maxtaganzeigen) and
       tagausgabe(akt,zuruck,fensterstarttag) do;
      {$B-}
      aktminnutz:=akt;
    end;

    procedure mausabfrage;
    var akt:integer;
        tasten,altx,alty,xpos,ypos:word;
        maussicht_:boolean;
        mauscursor:pointer;
        mouse:boolean;

      procedure bewegezeiger;
      begin
        if maussicht_ then begin
          putimage(altx-5,alty-5,mauscursor^,xorput);
          putimage(xpos-5,ypos-5,mauscursor^,xorput);
        end;
        altx:=xpos; alty:=ypos;
      end;

      procedure mausunsicht;
      begin
        if maussicht_ then begin
          putimage(altx-5,alty-5,mauscursor^,xorput);
          maussicht_:=false;
        end;
      end;

      procedure maussicht;
      begin
        if not maussicht_ then begin
          putimage(xpos-5,ypos-5,mauscursor^,xorput);
          maussicht_:=true;
          altx:=xpos;alty:=ypos;
        end;
      end;

      function mausin(x,y,xe,ye:word):boolean;
      begin
        mausin := (xpos >= x) and (xpos <= xe) and (ypos >= y) and (ypos <= ye);
      end;

      procedure bemerkunganzeigenaddzeit(tasten:byte);
      var spalte,hakt:word;

        procedure sethspalte;
        begin
          h:=nutz^[hakt].tag;
          spalte:=(succ(maxtaganzeigen)-h+fensterstarttag)*10;
        end;

        procedure zeitsumzeigen;
        var bufs,bufm:string[3];
        begin
          if not zeitsumgezeigt then begin
            bar(0,0,69*8,8);
            str(zeitsum div 60:3,bufs);
            str(zeitsum mod 60:3,bufm);
            outtextxy(0,0,'Summe: '+bufs+' Stunden'+bufm+' Minuten');
            zeitsumgezeigt:=true;
          end;
        end;

        procedure pliung;
        var n:word;
        begin
          n:=4000;
          while n>1000 do begin
            sound(n);
            n:=n-n div 128;
            delay(1);
          end;
          nosound;
        end;

        procedure ploing;
        var n:word;
        begin
          n:=1000;
          while n<4000 do begin
            sound(n);
            n:=n+n div 128;
            delay(1);
          end;
          nosound;
        end;

      begin
        if tasten=2 then begin
          zeitsum:=0;
          zeitsumgezeigt:=false;
          zeitsumzeigen;
          ploing;
          exit;
        end;
        if akt<succ(aktminnutz) then akt:=succ(aktminnutz);
        if akt>pred(aktmaxnutz) then akt:=pred(aktmaxnutz);
        if aktmaxnutz>0 then begin
          if akt=-1 then hakt:=succ(aktminnutz) else hakt:=akt;
          sethspalte;
          while not mausin(spalte,nutz^[hakt].beg,
                           spalte+8,nutz^[hakt].ende) do begin
            inc(hakt);
            if hakt>pred(aktmaxnutz) then begin
              if akt=-1 then begin
                if (ypos<15) and (xpos<69*8) then mausunsicht;
                zeitsumzeigen;
                maussicht;
                exit;
              end else hakt:=succ(aktminnutz);
            end;
            if nutz^[hakt].tag<>h then sethspalte;
            if hakt=akt then begin
              if (ypos<15) and (xpos<69*8) then mausunsicht;
              zeitsumzeigen;
              maussicht;
              akt:=-1;
              exit;
            end;
          end;

            {Provisorium}

          if tasten<>0 then begin
            if mouse then repeat until not mauskeypressed;
            with nutz^[hakt] do inc(zeitsum,(ende-beg)*3);
            pliung;
          end;

          {Provisorium Ende}

          if akt<>hakt then begin
            if (ypos<15) and (xpos<69*8) then mausunsicht;
            bar(0,0,69*8,8);
            if nutz^[hakt].text<>nil then
              outtextxy(0,0,eintrstr(nutz^[hakt].text^));
            zeitsumgezeigt:=false;
            maussicht;
            akt:=hakt;
          end;
        end;
      end;

    procedure schiebnachrechts(anz:byte);
    var h,akt:word;
        weiter:boolean;

      procedure verminderdatum;
      begin
        if d>1 then
          dec(d)
        else if m>1 then begin
          dec(m);
          d:=mlange[m];
          if ((y div 4)=0) and ((y div 200)<>0) and (m=2) then inc(d);
        end else begin
          dec(y);m:=12;d:=31;
        end;
      end;

    begin
      akt:=pred(aktmaxnutz);
      weiter:=true;
      while (nutz^[akt].tag<(maxtaganzeigen+fensterstarttag+anz)) and weiter do begin
        h:=akt;
        if (nutz^[akt].tag<(maxtaganzeigen+fensterstarttag)) then
          tagausgabe(h,zuruck,fensterstarttag);
        if (nutz^[akt].tag>=fensterstarttag+anz) then
          weiter:=tagausgabe(akt,zuruck,fensterstarttag+anz)
        else weiter:=tagausgabe(akt,zurucknichts,fensterstarttag+anz);
      end;
      inc(fensterstarttag,anz);
      while (aktmaxnutz>0) and (nutz^[pred(aktmaxnutz)].tag<fensterstarttag) do
        dec(aktmaxnutz);
      aktminnutz:=akt;
      for akt:=1 to anz do verminderdatum;
      letzttaganzeige;
    end;

    procedure schiebnachlinks(anz:byte);
    var h,akt:word;
        weiter:boolean;

      procedure erhohedatum;
      begin
        if (d<mlange[m]) or (((y div 4)=0) and ((y div 200)<>0) and (m=2) and (d=28)) then
          inc(d)
        else if m<12 then begin
          inc(m);
          d:=1;
        end else begin
          inc(y);
          m:=1;
          d:=1;
        end;
      end;

    begin
      akt:=succ(aktminnutz);
      weiter:=true;
      while (nutz^[akt].tag>=fensterstarttag-anz) and weiter do begin
        h:=akt;
        if (nutz^[akt].tag>=fensterstarttag) then {lschen}
          tagausgabe(h,vor,fensterstarttag);
        if (nutz^[akt].tag<fensterstarttag+maxtaganzeigen-anz) then
          weiter:=tagausgabe(akt,vor,fensterstarttag-anz)
          else tagausgabe(akt,vornichts,fensterstarttag-anz)
      end;
      aktmaxnutz:=akt;
      dec(fensterstarttag,anz);
      while (aktminnutz<succ(maxnutz)) and
            (nutz^[succ(aktminnutz)].tag>=fensterstarttag+maxtaganzeigen) do
        inc(aktminnutz);
      for akt:=1 to anz do erhohedatum;
      letzttaganzeige;
    end;

    procedure bewegemaustastatur;
    begin
       if keypressed then begin
         while keypressed do ein:=upcase(readkey);
         case ein of
           #73,#77,#81:begin inc(xpos,5);if xpos>maxx-5 then xpos:=maxx-5; end;
           #71,#75,#79:begin dec(xpos,5);if xpos>maxx-5 then xpos:=19; end;
           #57,#54,#51:begin inc(xpos,20);if xpos>maxx-5 then xpos:=maxx-5; end;
           #55,#52,#49:begin dec(xpos,20);if xpos>maxx-5 then xpos:=19; end;
         end;
         case ein of
           #71,#72,#73:begin dec(ypos,5);if ypos>maxy-24 then ypos:=5; end;
           #79,#80,#81:begin inc(ypos,5);if ypos>maxy-24 then ypos:=maxx-24; end;
           #55,#56,#57:begin dec(ypos,20);if ypos>maxy-24 then ypos:=5; end;
           #49,#50,#51:begin inc(ypos,20);if ypos>maxy-24 then ypos:=maxy-24; end;
         end;
         if mouse then maussetpos(xpos,ypos);
       end else ein:='@';
    end;

    procedure statistik;
    var n,m:byte;
        buf:pointer;
        bufgrose:word;
        textbuf:string[6];
        quotmin,quotanz:real;
        h,h2,hohe:word;

      procedure window(x1,y1,x2,y2:word);
      begin
        bufgrose:=imagesize(x1,y1,x2,y2);
        if maxavail>=bufgrose then begin
          getmem(buf,bufgrose);
          getimage(x1,y1,x2,y2,buf^);
        end else bufgrose:=0;
        bar(x1,y1,x2,y2);
        setcolor(blue);
        moveto(x1+1,y1+1);
        lineto(x2-1,y1+1);
        lineto(x2-1,y2-1);
        lineto(x1+1,y2-1);
        lineto(x1+1,y1+1);
        setviewport(x1,y1,x2,y2,true);
      end;

    begin
      mausunsicht;
      setwritemode(normalput);
      n:=0;
      while (n<maxuse) and (nutzer.n[n].zeichen<>' ') do inc(n);
      dec(n);
      hohe:=79+2*succ(n)*8;
      window(succ((maxx-40*8) div 2),(maxy-hohe) div 2-4,
               succ((maxx-40*8) div 2+41*8),(maxy-hohe) div 2+hohe-4);
      setcolor(red);
      settextstyle(gothicfont,horizdir,1);
      outtextxy(120,0,'Statistik');
      settextstyle(defaultfont,horizdir,1);
      setcolor(blue);
      outtextxy(4,20,'Minuten :');
      outtextxy(4,44+n*8,'Benutzt :');
      outtextxy(4,52+2*succ(n)*8,'Gesamt :       Minuten       Stunden');
      outtextxy(4+15*8,60+2*succ(n)*8,'Mal           Tage');
      outtextxy(4,68+2*succ(n)*8,'in      Tagen      Monaten       Jahre');
      setcolor(lightred);
      str(maxtagabstand:4,textbuf);
      outtextxy(4+3*8,68+2*succ(n)*8,textbuf);
      str(maxtagabstand/30:2:1,textbuf);
      outtextxy(4+16*8,68+2*succ(n)*8,textbuf);
      str(maxtagabstand/365:1:2,textbuf);
      outtextxy(4+30*8,68+2*succ(n)*8,textbuf);
      str(nutzstatgesmin:6,textbuf);
      outtextxy(4+8*8,52+2*succ(n)*8,textbuf);
      str(nutzstatgesmin div 60:4,textbuf);
      outtextxy(4+25*8,52+2*succ(n)*8,textbuf);
      str(nutzstatgesmin div 1440:4,textbuf);
      outtextxy(4+25*8,60+2*succ(n)*8,textbuf);
      str(nutzstatgesanz:5,textbuf);
      outtextxy(4+9*8,60+2*succ(n)*8,textbuf);
      quotmin:=34*8/nutzstatmaxmin;
      quotanz:=34*8/nutzstatmaxanz;
      for m:=0 to n do begin
        setcolor(nutzer.n[m].farbe);
        setfillstyle(solidfill,nutzer.n[m].farbe);
        h:=round(quotmin*nutzstat[m].minuten+4);
        bar(4,32+m*8,h,39+m*8);
        str(nutzstat[m].minuten:5,textbuf);
        outtextxy(284,32+m*8,textbuf);
        h2:=round(quotanz*nutzstat[m].anzahl+4);
        bar(4,48+m*8+succ(n)*8,h2,55+m*8+succ(n)*8);
        str(nutzstat[m].anzahl:5,textbuf);
        outtextxy(284,48+m*8+succ(n)*8,textbuf);
        setcolor(white);
        str(nutzstat[m].minuten/nutzstatgesmin*100:2:1,textbuf);
        if h<284-6*8 then outtextxy(h+4,32+m*8,textbuf+'%') else
          outtextxy(h-6*8,32+m*8,textbuf+'%');
        str(nutzstat[m].anzahl/nutzstatgesanz*100:2:1,textbuf);
        if h2<284-6*8 then outtextxy(h2+4,48+m*8+succ(n)*8,textbuf+'%') else
          outtextxy(h2-6*8,48+m*8+succ(n)*8,textbuf+'%');
      end;
      setfillstyle(solidfill,0);
      setviewport(0,0,maxx,maxy,false);
      setwritemode(xorput);
      maussicht;
      if mouse then repeat until not mauskeypressed;
      repeat
        repeat
          if mouse then maustastpos(tasten,xpos,ypos);
          bewegemaustastatur;
        until (xpos<>altx) or (ypos<>alty) or (tasten<>0) or (ein =#27);
        if (xpos<>altx) or (ypos<>alty) then bewegezeiger;
      until (ein=#27) or (ypos>10) or ((tasten=1) and mouse);
      setwritemode(normalput);
      mausunsicht;
      if bufgrose>0 then begin
        putimage(succ((maxx-40*8) div 2),(maxy-hohe) div 2-4,buf^,normalput);
        freemem(buf,bufgrose);
      end;
      setwritemode(xorput);
      maussicht;
      ein:=' ';
    end;

    function mausinxy(x1,y1,x2,y2:integer):boolean;
    begin
      mausinxy:=(xpos>=x1) and (xpos<=x2) and (ypos>=y1) and (ypos<=y2);
    end;

    begin
      setcolor(white);
      line(5,0,5,10);
      line(0,5,10,5);
      getmem(mauscursor,imagesize(0,0,10,10));
      getimage(0,0,10,10,mauscursor^);
      bar(0,0,10,10);
      akt:=-1;
      mausinit(tasten);
      mouse:=tasten<>0;
      if mouse then begin
        mausminmaxy(5,maxy-24);
        mausminmaxx(19,maxx-5);
      end;
      xpos:=maxx div 2;
      altx:=xpos;
      ypos:=maxy div 2;
      alty:=ypos;
      if mouse then maussetpos(xpos,ypos);
      bemerkunganzeigenaddzeit(0);
      maussicht_:=false;
      maussicht;
      repeat
        repeat
          if mouse then maustastpos(tasten,xpos,ypos);
          bewegemaustastatur;
        until (xpos<>altx) or (ypos<>alty) or (tasten<>0) or (ein in [#13,' ',#27,'S'])
           or (xpos<=95) or (xpos>=maxx-80) or (ypos<=10);
        if (xpos<>altx) or (ypos<>alty) then bewegezeiger;
        bemerkunganzeigenaddzeit(byte(tasten) or byte(ein=#13) or (byte(ein=' ') shl 1));
        if mausinxy(maxx-80,0,maxx,10) or (ein='S') then statistik 
        else if mausinxy(19,15,95,maxy-24) then begin
          if (maxtagabstand-nutz^[aktminnutz].tag>(16-((xpos-19) div 5))) then begin
              schiebnachrechts(16-((xpos-19) div 5))
            end else begin
              if maxtagabstand-nutz^[aktminnutz].tag>0 then
               schiebnachrechts(maxtagabstand-nutz^[aktminnutz].tag)
            end;
        end else begin
          if mausinxy(maxx-80,15,maxx,maxy-23) then begin
            if (fensterstarttag>((xpos-554) div 5)) then begin
              schiebnachlinks(((xpos-554) div 5))
            end else begin
              if fensterstarttag>0 then schiebnachlinks(fensterstarttag);
            end;
          end;
        end;
      until (ein=#27);
      mausunsicht;
      freemem(mauscursor,imagesize(0,0,10,10));
    end;

  begin
    new(nutz);
    lesenutz;
    grafikein;
    grafik;
    datenausgabe;
    mausabfrage;
    closegraph;
    dispose(nutz);
  end;

  procedure musik;
  begin
    while keypressed do readkey;
    swapvectors;
    case nutzer.sound of
      soIntern:begin
          SwapVectors;
          exec(nutzer.path+'melodie.exe','');
          SwapVectors;
          if doserror<>0 then writeln(#13#10'Doserror=',doserror,' '+nutzer.path+'MELODIE.EXE');
        end;
      soExtern:begin
          SwapVectors;
          exec(nutzer.command,nutzer.params);
          SwapVectors;
          if doserror<>0 then writeln(#13#10'Doserror=',doserror,' '+nutzer.command+' '+nutzer.params);
        end;
    end;
    swapvectors;
  end;

  procedure username;
  var ende:boolean;
      n:byte;
      ein:char;
      check:set of char;
  begin
    check:=[];
    for n:=0 to maxuse do if nutzer.n[n].zeichen<>' ' then
     check:=check+[nutzer.n[n].zeichen];
    writeln;
    writeln;
    write('Gebe den Anfangsbuchstaben deines Namens oder ');
    textcolor(lightgreen);
    write('+');
    textcolor(yellow);
    writeln(' fr mehrere Nutzer ein !');
    writeln;
    for n:=0 to maxuse do if nutzer.n[n].zeichen<>' ' then begin
      textcolor(lightgreen);
      write(nutzer.n[n].zeichen);textcolor(yellow);
      if nutzer.n[n].zeichen=nutzer.n[n].name[1] then
        write(copy(nutzer.n[n].name,2,pred(length(nutzer.n[n].name)))+' ')
      else write(':'+nutzer.n[n].name+' ');
    end;
    musik;
    repeat
      repeat until keypressed;
      ein:=upcase(readkey);
      if keypressed then begin
        ein:=' ';
        readkey;
      end;
    until (ein in check) or (ein='+');
    if ein='+' then begin
      writeln;
      writeln('Gebe die Anfangsbuchstaben aller Nutzer ein z.B. '+nutzer.n[0].zeichen+nutzer.n[1].zeichen);
      writeln;writeln;
      textcolor(lightgreen);
      repeat
        gotoxy(1,pred(wherey));
        readln(loginuser);
        ende:=length(loginuser)>0;
        for n:=1 to length(loginuser) do
         if not (loginuser[n] in check) then loginuser[n]:=upcase(loginuser[n]);
        for n:=1 to length(loginuser) do ende:=ende and (loginuser[n] in check);
      until ende;
    end else begin
      loginuser:=upcase(ein);
    end;
  end;

  procedure schreibelogindat(ftime:longint);
  var f:file;
      n:byte;
  begin
    assign(f,nutzer.path+'LOGIN.DAT');
    rewrite(f,1);
    blockwrite(f,ftime,sizeof(ftime));
    for n:=1 to length(loginuser) do blockwrite(f,loginuser[n],sizeof(loginuser[n]));
    close(f);
  end;

  procedure getdt;
  var hund:word;
  begin
    with dt do begin
      GetTime(hour,min,sec,hund);
      Getdate(year,month,day,dow);
    end;
  end;

  procedure zeit;
  var f: file;
      ftime,diskspace : Longint;
  begin
    textbackground(blue);
    if (nutzer.auto and auWarn>0) and (disksize(0)>5*1024*1024) then begin
      diskspace:=diskfree(0);
      if diskspace>1024*1024 then begin
        textcolor(lightgreen);
        write('Freier Festplattenspeicher ');
        textcolor(lightmagenta);
        write(diskspace);
        textcolor(lightgreen);
        writeln(' Bytes');
      end else if diskspace>1024*512 then begin
        textcolor(yellow+blink);
        write('Freier Festplattenspeicher nur ');
        textcolor(lightmagenta+blink);
        write(diskspace);
        textcolor(yellow+blink);
        writeln(' Bytes');
      end else begin
        textcolor(lightred+blink);
        write('Warnung! Freier Festplattenspeicher nur ');
        textcolor(lightmagenta+blink);
        write(diskspace);
        textcolor(lightred+blink);
        writeln(' Bytes',^G);
      end;
      writeln;
    end;
    textcolor(yellow);
    if loginexists then with logindt do begin
      writeln('Ich wurde zum letzten Mal am ',day,'.',month,'.',year,' um ',
      LeadingZero(Hour),':',LeadingZero(min),':',LeadingZero(sec),' angeschalten !');
    end;
    if nutzer.auto and auZeit>0 then with zeitdt do begin
      writeln('Ich wurde zum letzten Mal am ',day,'.',month,'.',year,' um ',
      LeadingZero(Hour),':',LeadingZero(min),':',LeadingZero(sec),' hochgefahren !');
    end;
    with dt do begin
      writeln('Heute haben wir ',days[dow],', den ',day,'.',month,'.',year,
      ' und es ist ',hour,':',LeadingZero(min),':',LeadingZero(sec),' !');
    end;
    getdt;
    Packtime(dt,ftime);
    if nutzer.auto and auZeit>0 then begin
      assign(f,nutzer.path+'NUTZUNG.EXE');
      reset(f);
      setftime(f,ftime);
      close(f);
    end;
    if not loginexists then begin
      username;
      schreibelogindat(ftime);
    end else musik;
  end;

  procedure statusausgabe;
  var ds,dm,dh:integer;
      mitternacht:integer;
  begin
    if not loginexists then begin
      textcolor(lightred+blink);
      writeln('Fehler: LOGIN.DAT nicht gefunden !');
      textcolor(yellow);
    end;
    with logindt do begin
      writeln('Du hast mich um ',LeadingZero(hour),':',LeadingZero(min),':',
              LeadingZero(sec),' angeschalten.');
      if nutzer.auto and auZeit>0 then writeln('Du hast mich um ',LeadingZero(zeitdt.hour),':',
              LeadingZero(zeitdt.min),':',LeadingZero(zeitdt.sec),' das letzte Mal gebootet.');
      writeln('Jetzt ist es ',LeadingZero(dt.hour),':',LeadingZero(dt.min),':',LeadingZero(dt.sec),' Uhr.');
      ds:=dt.sec-sec;
      if ds<0 then begin
        inc(min);
        ds:=ds+60;
      end;
      dm:=dt.min-min;
      if dm<0 then begin
        inc(hour);
        dm:=dm+60;
      end;
      if year<100 then begin
        if year>90 then inc(year,1900) else inc(year,2000);
      end;
      mitternacht:=tagabstand(logindt.day,logindt.month,logindt.year,dt.day,dt.month,dt.year);
      dh:=dt.hour-hour+24*mitternacht;
      writeln('Du hast mich also ',dh,' Stunden ',dm,' Minuten und ',ds,' Sekunden benutzt !');
    end;
  end;

  procedure parktime;
  var mitternacht:integer;
      t:text;
      f:file;
      ftime:longint;
      n:byte;
      geparkt:integer;
      schluss:string;
  begin
    if loginexists then begin
      assign(f,nutzer.path+'LOGIN.DAT');
      erase(f);
      assign(t,nutzer.path+'LOGBOOK.DAT');
      append(t);
      with logindt do begin
        if year<100 then begin
          if year>90 then inc(year,1900) else inc(year,2000);
        end;
        mitternacht:=tagabstand(logindt.day,logindt.month,logindt.year,dt.day,dt.month,dt.year);
        year:=round(frac(year/100)*100);
        for n:=1 to length(loginuser) do write(t,loginuser[n]);
        write(t,' ',day:2,' ',Month:2,' ',Year:2,' ',mitternacht:1,' ',Hour:2,' ',Min:2,' ',dt.hour:2,' ',dt.min:2);
      end;
      if paramcount>1 then begin
        for n:=2 to paramcount do write(t,' ',paramstr(n));
      end else if nutzer.auto and auschluss>0 then begin
        textbackground(blue);
        textcolor(yellow);
        clrscr;
        gotoxy(1,10);
        writeln('Gebe die Abschlubemerkung ein:');
        textcolor(lightgreen);
        repeat
          gotoxy(1,11);
          readln(schluss);
          while (schluss[1]=' ') and (schluss<>'') do delete(schluss,1,1);
        until schluss<>'';
        write(t,' ',schluss);
      end;
      writeln(t);
      close(t);
    end;
    if nutzer.auto and auPark >0 then begin
      SwapVectors;
      exec(nutzer.path+'NUTZPARK.EXE','');
      SwapVectors;
      if doserror<>0 then begin
        SwapVectors;
        exec(nutzer.path+'NUTZPARK.COM','');
        SwapVectors;
      end;
      geparkt:=doserror;
    end;
    textbackground(blue);
    textcolor(yellow);
    clrscr;
    gotoxy(1,10);
    statusausgabe;
    textcolor(lightgreen);
    if paramcount>1 then begin
      for n:=2 to paramcount do write(paramstr(n),' ');writeln;
    end else if nutzer.auto and auSchluss>0 then writeln(schluss);
    textcolor(yellow);
    if nutzer.auto and auPark>0 then begin
      if geparkt=0 then writeln('Ich habe mich geparkt, Du kannst mich jetzt ausschalten !')
      else begin
        writeln('Doserror=',geparkt,' Ich konnte mich nicht parken, da ich die Datei');
        writeln(nutzer.path+'NUTZPARK.EXE nicht ausfhren konnte  !');
      end;
    end;
    repeat until keypressed;
    username;
    getdt;
    logindt:=dt;
    packtime(dt,ftime);
    schreibelogindat(ftime);;
  end;

  procedure getdata;
  var f:file;
      ftime:longint;

      suche:searchrec;
      ein:char;
  begin
    getdt;
    if nutzer.auto and auZeit>0 then begin
      Assign(f,nutzer.path+'NUTZUNG.EXE');
      reset(f);
      GetFTime(f,ftime); { Erstellungsdatum }
      close(f);
      UnpackTime(ftime,zeitdt);
    end;
    suche.name:=nutzer.path+'LOGIN.DAT';
    findfirst(nutzer.path+'LOGIN.DAT',anyfile,suche);
    loginexists:=doserror=0;
    if loginexists then begin
      assign(f,nutzer.path+'LOGIN.DAT');
      reset(f,1);
      blockread(f,ftime,sizeof(ftime));
      UnpackTime(ftime,logindt);
      loginuser:='';
      repeat
        blockread(f,ein,sizeof(ein));
        loginuser:=loginuser+ein;
      until eof(f);
      close(f);
    end;
  end;

  procedure user;
  var n:byte;
  begin
    textbackground(blue);
    textcolor(yellow);
    write('Zur Zeit benutzt mich ');
    textcolor(lightgreen);
    n:=0;
    while (nutzer.n[n].zeichen<>loginuser) and (n<maxuse) do inc(n);
    if (nutzer.n[n].zeichen=loginuser) then write(nutzer.n[n].name) else write('ein Unbekannter');
    textcolor(yellow);
    writeln(' !');
    statusausgabe;
  end;

begin
  getdata;
  if paramcount=0 then begin
    ausnutzung('LOGBOOK');
    user;
  end else begin
    param:=paramstr(1);
    if ('Z'=upcase(param[1])) then zeit
    else if ('P'=upcase(param[1])) then parktime
    else begin
      ausnutzung(param);
      user;
    end;
  end;
  textcolor(yellow);
  writeln;
  if length(loginuser)=1 then
   halt(usernr(loginuser[1]))
  else halt(succ(maxuse));
end.